# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section		free
%define grname		excalibur

Name:		avalon-framework
Version:	4.3
Release:	4jpp
Epoch:		0
Summary:	Avalon Framework
License:	Apache Software License 2.0
Url:		http://excalibur.apache.org/
Group:		Development/Libraries/Application Frameworks
Vendor:		JPackage Project
Distribution:	JPackage
Source0:	http://www.apache.org/dist/excalibur/avalon-framework/source/avalon-framework-api-4.3-src.tar.gz
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        avalon-framework-4.3-jpp-depmap.xml
Source5:        excalibur-avalon-framework-project-common.xml
Source6:        excalibur-buildsystem.tar.gz
Source7:	http://www.apache.org/dist/excalibur/avalon-framework/source/avalon-framework-impl-4.3-src.tar.gz
Patch0:         excalibur-avalon-framework-api-4.3-project_xml.patch
Patch1:         excalibur-avalon-framework-impl-4.3-project_xml.patch
BuildRequires:	maven >= 0:1.1
BuildRequires:	junit
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:	excalibur-avalon-logkit
BuildRequires:  jakarta-commons-logging
BuildRequires:  jmock
BuildRequires:  log4j
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis

Requires:       excalibur-avalon-logkit
Requires:       jakarta-commons-logging
Requires:       log4j
Requires:       xalan-j2
Requires:       xerces-j2
Requires:       xml-commons-apis
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
The Avalon Framework consists of interfaces that define 
relationships between commonly used application components, 
best-of-practice pattern enforcements, and several lightweight 
convenience implementations of the generic components

%package -n excalibur-avalon-framework-api
Summary:	Avalon Framework API
Group:		Development/Libraries/Application Frameworks
Requires:	excalibur-avalon-logkit

%description -n excalibur-avalon-framework-api
%{summary}.

%package -n excalibur-avalon-framework-impl
Summary:	Avalon Framework Implementation
Group:		Development/Libraries/Application Frameworks
Requires:       excalibur-avalon-framework-api
Requires:       excalibur-avalon-logkit
Requires:       jakarta-commons-logging
Requires:       log4j
Requires:       xalan-j2
Requires:       xerces-j2
Requires:       xml-commons-apis

%description -n excalibur-avalon-framework-impl
%{summary}.

%package -n excalibur-avalon-framework-api-javadoc
Summary:        Javadoc for %{name} API
Group:          Development/Documentation

%description -n excalibur-avalon-framework-api-javadoc
%{summary}.

%package -n excalibur-avalon-framework-impl-javadoc
Summary:        Javadoc for %{name} Implementation
Group:          Development/Documentation

%description -n excalibur-avalon-framework-impl-javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -c -n %{name}-%{version}
gzip -dc %{SOURCE7} | tar xf -
# remove all binary libs
#find . -name "*.jar" -exec rm -f {} \;
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done
pushd %{name}-api-%{version}
cp %{SOURCE5} project-common.xml
gzip -dc %{SOURCE6} | tar xf -
%patch0 -b .sav
popd
pushd %{name}-impl-%{version}
cp %{SOURCE5} project-common.xml
gzip -dc %{SOURCE6} | tar xf -
%patch1 -b .sav
popd


%build
export DEPCAT=$(pwd)/avalon-framework-4.3-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > avalon-framework-4.3-depmap.new.xml
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

export MAVEN_HOME_LOCAL=$(pwd)/.maven

pushd %{name}-api-%{version}
maven \
	-Dmaven.repo.remote=file:/usr/share/maven/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar javadoc
popd
pushd %{name}-impl-%{version}
maven \
	-Dmaven.repo.remote=file:/usr/share/maven/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar javadoc
popd
mkdir target
pushd target
jar xf ../%{name}-impl-%{version}/target/%{name}-impl-%{version}.jar
jar xf ../%{name}-api-%{version}/target/%{name}-api-%{version}.jar
jar cf %{name}-%{version}.jar *
popd


%install
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{grname}
install -m 644 \
	target/%{name}-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 \
	%{name}-api-%{version}/target/%{name}-api-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{grname}/%{name}-api-%{version}.jar
install -m 644 \
	%{name}-impl-%{version}/target/%{name}-impl-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{grname}/%{name}-impl-%{version}.jar

# create unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/ && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{grname} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-api-%{version}
cp -pr %{name}-api-%{version}/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-api-%{version}
ln -s %{name}-api-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-api # ghost symlink
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-impl-%{version}
cp -pr %{name}-impl-%{version}/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-impl-%{version}
ln -s %{name}-impl-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-impl # ghost symlink


install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp %{name}-api-%{version}/LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


%clean
rm -rf $RPM_BUILD_ROOT

%post -n excalibur-avalon-framework-api-javadoc
rm -f %{_javadocdir}/%{name}-api
ln -s %{name}-api-%{version} %{_javadocdir}/%{name}-api

%post -n excalibur-avalon-framework-impl-javadoc
rm -f %{_javadocdir}/%{name}-impl
ln -s %{name}-impl-%{version} %{_javadocdir}/%{name}-impl

%postun -n excalibur-avalon-framework-api-javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}-api
fi

%postun -n excalibur-avalon-framework-impl-javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}-impl
fi


%files 
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/*.jar

%files -n excalibur-avalon-framework-api
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/%{grname}/%{name}-api*.jar

%files -n excalibur-avalon-framework-impl
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/%{grname}/%{name}-impl*.jar

%files -n excalibur-avalon-framework-api-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-api-%{version}
%ghost %{_javadocdir}/%{name}-api

%files -n excalibur-avalon-framework-impl-javadoc
%{_javadocdir}/%{name}-impl-%{version}
%ghost %{_javadocdir}/%{name}-impl

%changelog
* Wed Jun 21 2006 Ralph Apel <r.apel at r-apel.de> 0:4.3-4jpp
- Fusion excalibur-avalon-framework-api and excalibur-avalon-framework-impl
  into one SRPM and provide a fusioned library

* Thu Mar 23 2006 Ralph Apel <r.apel at r-apel.de> 0:4.3-3jpp
- Drop explicit ant requirement

* Wed Mar 22 2006 Ralph Apel <r.apel at r-apel.de> 0:4.3-2jpp
- First JPP-1.7 release

* Wed Sep 07 2005 Ralph Apel <r.apel at r-apel.de> 0:4.3-1jpp
- First build from this codebase
